/*
 * AbstractFileSelectorWizardPanel.java
 *
 * Copyright (C) 2012 Christian Mayer
 *
 * This file is part of CellXGui
 *
 */

/*
 * AbstractFileSelectorWizardPanel.java
 *
 * Created on Feb 14, 2012, 11:16:12 AM
 */
package cellxgui.view.dialogs.wizard;

import cellxgui.view.TextArea;
import java.beans.PropertyChangeEvent;
import java.io.File;
import javax.swing.JFileChooser;

/**
 *
 * @author Christian Mayer <chrixian.mayer@gmail.com>
 */
abstract public class AbstractFileSelectorWizardPanel extends WizardPanel {

    private final TextArea textArea;
    private File initDir = null;

    /** Creates new form AbstractFileSelectorWizardPanel */
    public AbstractFileSelectorWizardPanel() {
        initComponents();
        errMsgLabel.setVisible(false);
        textArea = new TextArea();
        textArea.setBackground(this.getBackground());
        textArea.setWrapStyleWord(true);
        textArea.setLineWrap(true);
        jScrollPane1.setViewportView(textArea);
        jScrollPane1.setBorder(null);
        validate();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        selectBtn = new javax.swing.JButton();
        textField = new javax.swing.JTextField();
        errMsgLabel = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();

        setMinimumSize(new java.awt.Dimension(400, 250));
        setPreferredSize(new java.awt.Dimension(400, 250));

        selectBtn.setText("Select File");
        selectBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                selectBtnActionPerformed(evt);
            }
        });

        errMsgLabel.setForeground(new java.awt.Color(255, 0, 0));
        errMsgLabel.setText("error msg");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(33, 33, 33)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(textField, javax.swing.GroupLayout.PREFERRED_SIZE, 338, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 338, Short.MAX_VALUE)
                            .addComponent(selectBtn, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(errMsgLabel, javax.swing.GroupLayout.Alignment.LEADING))
                        .addContainerGap(29, Short.MAX_VALUE))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(32, 32, 32)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(errMsgLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(textField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(selectBtn)
                .addContainerGap(36, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void selectBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectBtnActionPerformed
        final JFileChooser jfc = new JFileChooser();
        jfc.setMultiSelectionEnabled(false);
        jfc.setApproveButtonText("Set");
        jfc.setMultiSelectionEnabled(false);
        if (initDir != null) {
            jfc.setCurrentDirectory(initDir);
        }
        if (jfc.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
            textField.setText(jfc.getSelectedFile().getName());
            if (!validData()) {
                return;
            }
            commitData();
            firePropertyChange(Wizard.JUMP_TO, null, getNextWizardPanel());
        }
    }//GEN-LAST:event_selectBtnActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel errMsgLabel;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton selectBtn;
    protected javax.swing.JTextField textField;
    // End of variables declaration//GEN-END:variables

    @Override
    public void propertyChange(PropertyChangeEvent evt) {
        if (evt.getPropertyName().equals(FlatFieldModel.FILENAME_PROPERTY)) {
            textField.setText((String) evt.getNewValue());
        }
    }

    public void setText(String txt) {
        textArea.setText(txt);
    }

    public void showErrorMessage(String msg) {
        errMsgLabel.setText(msg);
        errMsgLabel.setVisible(true);
    }

    public void hideErrorMessage() {
        errMsgLabel.setVisible(false);
    }

    public void setFileDialogDirectory(File d) {
        initDir = d;
    }
}
